package com.cesgroup.cesmonitor.bean;

import java.io.Serializable;

/**
 * CPU使用率报表
 *
 * @author user
 * @version 1.0.0 2017年5月11日
 */
public class CPUUsageRateReport implements Serializable {

    private static final long serialVersionUID = 1L;

    private String name;

    private String host;

    private String hname;

    private double valueMin;

    private double valueAvg;

    private double valueMax;

    public CPUUsageRateReport() {
    }

    /**
     *
     * @param name
     *            主机组
     * @param host
     *            主机
     * @param valueMin
     *            最小值
     * @param valueAvg
     *            平均值
     * @param valueMax
     *            最大值
     */
    public CPUUsageRateReport(final String name, final String host, final String hname, final double valueMin,
        final double valueAvg,
        final double valueMax) {
        this.name = name;
        this.host = host;
        this.hname = hname;
        this.valueMin = valueMin;
        this.valueAvg = valueAvg;
        this.valueMax = valueMax;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    public String getHost() {
        return host;
    }

    public void setHost(final String host) {
        this.host = host;
    }

    public String getHname() {
        return hname;
    }

    public void setHname(final String hname) {
        this.hname = hname;
    }

    public double getValueMin() {
        return valueMin;
    }

    public void setValueMin(final double valueMin) {
        this.valueMin = valueMin;
    }

    public double getValueAvg() {
        return valueAvg;
    }

    public void setValueAvg(final double valueAvg) {
        this.valueAvg = valueAvg;
    }

    public double getValueMax() {
        return valueMax;
    }

    public void setValueMax(final double valueMax) {
        this.valueMax = valueMax;
    }

    @Override
    public String toString() {
        return "CPUUsageRateReport [name=" + name + ", host=" + host + ", hname=" + hname + ", valueMin=" + valueMin
            + ", valueAvg=" + valueAvg + ", valueMax=" + valueMax + "]";
    }
}