/**
 * <p>Copyright:Copyright(c) 2017</p>
 * <p>Company:上海中信信息发展股份有限公司</p>
 * <p>包名:com.cesgroup.cesmonitor.bean</p>
 * <p>文件名:DiskUsageRateReport.java</p>
 * <p>创建时间:2017年5月11日 下午1:32:49</p>
 * <p>作者:user</p>
 */

package com.cesgroup.cesmonitor.bean;

import java.io.Serializable;

/**
 * 磁盘使用率报表
 *
 * @author user
 * @version 1.0.0 2017年5月11日
 */
public class DiskUsageRateReport implements Serializable {

    private static final long serialVersionUID = 1L;

    private String name;

    private String host;

    private String hname;

    private String itemName; //监控项的name

    private String itemKey; //监控项的key，考虑到name中可能存在$符号，所以引入key，进行解析

    private double valueMin;

    private double valueAvg;

    private double valueMax;

    public DiskUsageRateReport() {
        super();
    }

    /**
     *
     * @param name
     *            主机组
     * @param host
     *            主机
     * @param hname
     *            主机可见名
     * @param itemName
     *            监控项名字
     * @param itemKey
     *            监控项的key
     * @param valueMin
     *            最小值
     * @param valueAvg
     *            平均值
     * @param valueMax
     *            最大值
     */
    public DiskUsageRateReport(final String name, final String host, final String hname, final String itemName,
        final String itemKey, final double valueMin,
        final double valueAvg, final double valueMax) {
        super();
        this.name = name;
        this.host = host;
        this.hname = hname;
        this.itemName = itemName;
        this.itemKey = itemKey;
        this.valueMin = valueMin;
        this.valueAvg = valueAvg;
        this.valueMax = valueMax;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    public String getHost() {
        return host;
    }

    public void setHost(final String host) {
        this.host = host;
    }

    public String getHname() {
        return hname;
    }

    public void setHname(final String hname) {
        this.hname = hname;
    }

    public String getItemName() {
        return itemName;
    }

    public void setItemName(final String itemName) {
        this.itemName = itemName;
    }

    public String getItemKey() {
        return itemKey;
    }

    public void setItemKey(final String itemKey) {
        this.itemKey = itemKey;
    }

    public double getValueMin() {
        return valueMin;
    }

    public void setValueMin(final double valueMin) {
        this.valueMin = valueMin;
    }

    public double getValueAvg() {
        return valueAvg;
    }

    public void setValueAvg(final double valueAvg) {
        this.valueAvg = valueAvg;
    }

    public double getValueMax() {
        return valueMax;
    }

    public void setValueMax(final double valueMax) {
        this.valueMax = valueMax;
    }

    @Override
    public String toString() {
        return "DiskUsageRateReport [name=" + name + ", host=" + host + ", itemName=" + itemName + ", itemKey="
            + itemKey + ", valueMin=" + valueMin + ", valueAvg=" + valueAvg + ", valueMax=" + valueMax + "]";
    }
}
