/**
 * <p>Copyright:Copyright(c) 2017</p>
 * <p>Company:上海中信信息发展股份有限公司</p>
 * <p>包名:com.cesgroup.cesmonitor.bean</p>
 * <p>文件名:InterfaceIncomingReport.java</p>
 * <p>创建时间:2017年5月12日 上午10:22:55</p>
 * <p>作者:user</p>
 */

package com.cesgroup.cesmonitor.bean;

import java.io.Serializable;

/**
 * 接口流入流量报表
 *
 * @author user
 * @version 1.0.0 2017年5月12日
 */
public class InterfaceIncomingReport implements Serializable {

    private static final long serialVersionUID = 1L;

    private String name;

    private String host;

    private String hname;

    private String itemName;

    private String itemKey;

    private double valueMin;

    private double valueAvg;

    private double valueMax;

    private String accuracy;

    public String getAccuracy() {
        return accuracy;
    }

    public void setAccuracy(final String accuracy) {
        this.accuracy = accuracy;
    }

    public InterfaceIncomingReport() {
        super();
    }

    /**
     *
     * @param name
     *            主机组
     * @param host
     *            主机
     * @param hname
     *            主机可见名
     * @param itemName
     *            监控项
     * @param itemKey
     *            监控key_,考虑到name中存在$符号，需对其进行解析
     * @param valueMin
     *            最小值
     * @param valueAvg
     *            平均值
     * @param valueMax最大值
     */
    public InterfaceIncomingReport(final String name, final String host, final String hname, final String itemName,
        final String itemKey,
        final double valueMin, final double valueAvg, final double valueMax) {
        super();
        this.name = name;
        this.host = host;
        this.hname = hname;
        this.itemName = itemName;
        this.itemKey = itemKey;
        this.valueMin = valueMin;
        this.valueAvg = valueAvg;
        this.valueMax = valueMax;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    public String getHost() {
        return host;
    }

    public void setHost(final String host) {
        this.host = host;
    }

    public String getHname() {
        return hname;
    }

    public void setHname(final String hname) {
        this.hname = hname;
    }

    public String getItemName() {
        return itemName;
    }

    public void setItemName(final String itemName) {
        this.itemName = itemName;
    }

    public String getItemKey() {
        return itemKey;
    }

    public void setItemKey(final String itemKey) {
        this.itemKey = itemKey;
    }

    public double getValueMin() {
        return valueMin;
    }

    public void setValueMin(final double valueMin) {
        this.valueMin = valueMin;
    }

    public double getValueAvg() {
        return valueAvg;
    }

    public void setValueAvg(final double valueAvg) {
        this.valueAvg = valueAvg;
    }

    public double getValueMax() {
        return valueMax;
    }

    public void setValueMax(final double valueMax) {
        this.valueMax = valueMax;
    }

    @Override
    public String toString() {
        return "InterfaceIncomingReport [name=" + name + ", host=" + host + ", hname=" + hname + ", itemName="
            + itemName + ", itemKey=" + itemKey + ", valueMin=" + valueMin + ", valueAvg=" + valueAvg + ", valueMax="
            + valueMax + "]";
    }
}
