package com.cesgroup.cesmonitor.bean;

import java.io.Serializable;

/**
 * 响应时间报表
 *
 * @author user
 * @version 1.0.0 2017年5月11日
 */
public class ResponseTimeReport implements Serializable {

    private static final long serialVersionUID = 1L;

    private String name;

    private String host;

    private String hname;

    private double valueMin;

    private double valueAvg;

    private double valueMax;

    public ResponseTimeReport() {
    }

    /**
     *
     * @param name
     *            主机组
     * @param host
     *            主机
     * @param hname
     *            主机可见名
     * @param valueMin
     *            最小值
     * @param valueAvg
     *            平均值
     * @param valueMax
     *            最大值
     */
    public ResponseTimeReport(final String name, final String host, final String hname, final double valueMin,
        final double valueAvg,
        final double valueMax) {
        this.name = name;
        this.host = host;
        this.hname = hname;
        this.valueMin = valueMin;
        this.valueAvg = valueAvg;
        this.valueMax = valueMax;
    }

    public final String getName() {
        return this.name;
    }

    public final void setName(final String name) {
        this.name = name;
    }

    public final String getHost() {
        return this.host;
    }

    public final void setHost(final String host) {
        this.host = host;
    }

    public String getHname() {
        return hname;
    }

    public void setHname(final String hname) {
        this.hname = hname;
    }

    public final double getValueMin() {
        return this.valueMin;
    }

    public final void setValueMin(final double valueMin) {
        this.valueMin = valueMin;
    }

    public final double getValueAvg() {
        return this.valueAvg;
    }

    public final void setValueAvg(final double valueAvg) {
        this.valueAvg = valueAvg;
    }

    public final double getValueMax() {
        return this.valueMax;
    }

    public final void setValueMax(final double valueMax) {
        this.valueMax = valueMax;
    }

    @Override
    public String toString() {
        return "ResponseTimeReport [name=" + name + ", host=" + host + ", hname=" + hname + ", valueMin=" + valueMin
            + ", valueAvg=" + valueAvg + ", valueMax=" + valueMax + "]";
    }

}