package com.cesgroup.cesmonitor.service;

import java.io.Serializable;

import com.zabbix4j.ZabbixApi;
import com.zabbix4j.user.UserObject;

/**
 * 登录用户
 *
 * @author zhang.erwei
 * @version 1.0.0 2017年5月24日
 */
public class LoginUser extends UserObject implements Serializable {

    //    private String name;

    private String username;

    private String password;

    private transient ZabbixApi zabbixApi;

    //    @Override
    //    public String getName() {
    //        return name;
    //    }
    //
    //    @Override
    //    public void setName(String name) {
    //        this.name = name;
    //    }

    /**
     * 是否是管理员
     *
     * @return 是否是管理员
     */
    public boolean isAdmin() {
        if (this.getType() == null) {
            return false;
        }
        return this.getType() == 2;
    }

    /**
     * 是否超级管理员
     *
     * @return 是否超级管理员
     */
    public boolean isSuperAdmin() {
        if (this.getType() == null) {
            return false;
        }
        return this.getType() == 3;
    }

    /**
     * 是否一般用户
     *
     * @return 是否一般用户
     */
    public boolean isUser() {
        if (this.getType() == null) {
            return false;
        }
        return this.getType() == 1;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public ZabbixApi getZabbixApi() {
        return zabbixApi;
    }

    public void setZabbixApi(ZabbixApi zabbixApi) {
        this.zabbixApi = zabbixApi;
    }
}