CREATE TABLE QRTZ_FRAMEWORK_JOBS
(
  id              VARCHAR(32) not null,
  name            VARCHAR(200) not null,
  concurrent      CHAR(1) not null,
  cron_expression VARCHAR(200),
  description     VARCHAR(250),
  target_bean     VARCHAR(250),
  target_method   VARCHAR(250),
  start_time      TIMESTAMP(6) not null,
  end_time        TIMESTAMP(6),
  priority        BIGINT(13),
  calendar_name   VARCHAR(200), 
  CONSTRAINT PK_QRTZ_FRAMEWORK_JOBS PRIMARY KEY (ID)
)ENGINE=InnoDB;
comment on column QRTZ_FRAMEWORK_JOBS.id is 'PK';
comment on column QRTZ_FRAMEWORK_JOBS.name is '任务名称';
comment on column QRTZ_FRAMEWORK_JOBS.concurrent is '是否允许并发执行';
comment on column QRTZ_FRAMEWORK_JOBS.cron_expression is '运行时间表达式';
comment on column QRTZ_FRAMEWORK_JOBS.description is '任务描述';
comment on column QRTZ_FRAMEWORK_JOBS.target_bean is '目标Bean名称';
comment on column QRTZ_FRAMEWORK_JOBS.target_method is '目标方法';
comment on column QRTZ_FRAMEWORK_JOBS.start_time is '开始时间';
comment on column QRTZ_FRAMEWORK_JOBS.end_time is '结束时间';
comment on column QRTZ_FRAMEWORK_JOBS.priority is '优先级';
comment on column QRTZ_FRAMEWORK_JOBS.calendar_name is '日历名称';
create index QRTZ_FRAMEWORK_JOBS_NAMEIDX on QRTZ_FRAMEWORK_JOBS (name);
